# Reporting Fees

### What is the `DelayedFeeCalculator`?

Every `FeeVault` (a vault that is capable of charging fees) has to use the corresponding fee calculator. For single-depositor vaults the fee calculator operates on a review model where the each snapshot is automatically approved once the dispute period is passed.

Each fee calculator designates a special operator called the accountant which submits the vault's fee inputs on a regular cadence (the variables required to calculate earned TVL and performance fees).

### Why it Matters

In order to collect fees fairly, each vault needs to be able to calculate the value of its holdings. Since Aera vaults can support arbitrary assets, a universal onchain calculation is not possible. Instead, an accountant needs to compute the fees accumulating and report it to the vault.

Doing so naively could lead to accidental price spikes so the `DelayedFeeCalculator` provides a dispute period within which the vault owner could effectively reject the latest proposed vault fee calculation.

### How to Report Prices as an Accountant

The designated vault accountant can report a snapshot using `submitSnapshot` with the following arguments:

* `vault` is the vault to submit the snapshot for (a single `DelayedFeeCalculator` supports multiple vaults)
* `averageValue` is the average vault value over the period between the last snapshot and the current snapshot (used for TVL calculation)
* `highestProfit` is the highest overall profit achieved so far
* `timestamp` is the timestamp when the snapshot was computed

### Caveats

When a new snapshot is submitted but the dispute period hasn't passed for the previous snapshot, the previous snapshot will be overridden.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.aera.finance/single-depositor-vaults/reporting-fees.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
